Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util
Class Hashtable

    java.lang.Object
      |
      +--java.util.Dictionary
            |
            +--java.util.Hashtable

All Implemented Interfaces:
  Cloneable, Map, Serializable

Direct Known Subclasses:
  Properties, UIDefaults

public class Hashtable
extends Dictionary
implements Map, Cloneable, Serializable

This class implements a hashtable, which maps keys to values. Any non-`null` object can be used as a key or as a value.

To successfully store and retrieve objects from a hashtable, the objects used as keys must implement the `hashCode` method and the `equals` method.

An instance of `Hashtable` has two parameters that affect its performance: initial capacity and load factor. The capacity is the number of buckets in the hash table, and the initial capacity is simply the capacity at the time the hash table is created. Note that the hash table is open: in the case a "hash collision", a single bucket stores multiple entries, which must be searched sequentially. The load factor is a measure of how full the hash table is allowed to get before its capacity is automatically increased. When the number of entries in the hashtable exceeds the product of the load factor and the current capacity, the capacity is increased by calling the `rehash` method.

Generally, the default load factor (.75) offers a good tradeoff between time and space costs. Higher values decrease the space overhead but increase the time cost to look up an entry (which is reflected in most `Hashtable` operations, including `get` and `put`).

The initial capacity controls a tradeoff between wasted space and the need for `rehash` operations, which are time-consuming. No `rehash` operations will ever occur if the initial capacity is greater than the maximum number of entries the `Hashtable` will contain divided by its load factor. However, setting the initial capacity too high can waste space.

If many entries are to be made into a `Hashtable`, creating it with a sufficiently large capacity may allow the entries to be inserted more efficiently than letting it perform automatic rehashing as needed to grow the table.

This example creates a hashtable of numbers. It uses the names of the numbers as keys:

>          Hashtable numbers = new Hashtable();
>          numbers.put("one", new Integer(1));
>          numbers.put("two", new Integer(2));
>          numbers.put("three", new Integer(3));

To retrieve a number, use the following code:

>          Integer n = (Integer)numbers.get("two");
>          if (n != null) {
>              System.out.println("two = " + n);
>          }

As of the Java 2 platform v1.2, this class has been retrofitted to implement Map, so that it becomes a part of Java's collection framework. Unlike the new collection implementations, Hashtable is synchronized.

The Iterators returned by the iterator and listIterator methods of the Collections returned by all of Hashtable's "collection view methods" are fail-fast: if the Hashtable is structurally modified at any time after the Iterator is created, in any way except through the Iterator's own remove or add methods, the Iterator will throw a ConcurrentModificationException. Thus, in the face of concurrent modification, the Iterator fails quickly and cleanly, rather than risking arbitrary, non-deterministic behavior at an undetermined time in the future. The Enumerations returned by Hashtable's keys and values methods are not fail-fast.

Since:
  JDK1.0
See Also:
  `Object.equals(java.lang.Object)`, `Object.hashCode()`, `rehash()`, `Collection`, `Map`, `HashMap`, `TreeMap`, Serialized Form

Inner classes inherited from class java.util.Map
`Map.Entry`

Constructor Summary
`Hashtable()` Constructs a new, empty hashtable with a default capacity and load factor, which is `0.75`.
`Hashtable(int initialCapacity)` Constructs a new, empty hashtable with the specified initial capacity and default load factor, which is `0.75`.
`Hashtable(int initialCapacity, float loadFactor)` Constructs a new, empty hashtable with the specified initial capacity and the specified load factor.
`Hashtable(Map t)` Constructs a new hashtable with the same mappings as the given Map.

Method Summary
`void` | `clear()` Clears this hashtable so that it contains no keys.
`Object` | `clone()` Creates a shallow copy of this hashtable.
`boolean` | `contains(Object value)` Tests if some key maps into the specified value in this hashtable.
`boolean` | `containsKey(Object key)` Tests if the specified object is a key in this hashtable.
`boolean` | `containsValue(Object value)` Returns true if this Hashtable maps one or more keys to this value.
`Enumeration` | `elements()` Returns an enumeration of the values in this hashtable.
`Set` | `entrySet()` Returns a Set view of the entries contained in this Hashtable.
`boolean` | `equals(Object o)` Compares the specified Object with this Map for equality, as per the definition in the Map interface.
`Object` | `get(Object key)` Returns the value to which the specified key is mapped in this hashtable.
`int` | `hashCode()` Returns the hash code value for this Map as per the definition in the Map interface.
`boolean` | `isEmpty()` Tests if this hashtable maps no keys to values.
`Enumeration` | `keys()` Returns an enumeration of the keys in this hashtable.
`Set` | `keySet()` Returns a Set view of the keys contained in this Hashtable.
`Object` | `put(Object key, Object value)` Maps the specified `key` to the specified `value` in this hashtable.
`void` | `putAll(Map t)` Copies all of the mappings from the specified Map to this Hashtable These mappings will replace any mappings that this Hashtable had for any of the keys currently in the specified Map.
`protected void` | `rehash()` Increases the capacity of and internally reorganizes this hashtable, in order to accommodate and access its entries more efficiently.
`Object` | `remove(Object key)` Removes the key (and its corresponding value) from this hashtable.
`int` | `size()` Returns the number of keys in this hashtable.
`String` | `toString()` Returns a string representation of this `Hashtable` object in the form of a set of entries, enclosed in braces and separated by the ASCII characters "`,` " (comma and space).
`Collection` | `values()` Returns a Collection view of the values contained in this Hashtable.

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Hashtable

    public Hashtable(int initialCapacity,
                     float loadFactor)

  Constructs a new, empty hashtable with the specified initial capacity and the specified load factor.
  Parameters:
    `initialCapacity` - the initial capacity of the hashtable.
    `loadFactor` - the load factor of the hashtable.
  Throws:
    `IllegalArgumentException` - if the initial capacity is less than zero, or if the load factor is nonpositive.

### Hashtable

    public Hashtable(int initialCapacity)

  Constructs a new, empty hashtable with the specified initial capacity and default load factor, which is `0.75`.
  Parameters:
    `initialCapacity` - the initial capacity of the hashtable.
  Throws:
    `IllegalArgumentException` - if the initial capacity is less than zero.

### Hashtable

    public Hashtable()

  Constructs a new, empty hashtable with a default capacity and load factor, which is `0.75`.

### Hashtable

    public Hashtable(Map t)

  Constructs a new hashtable with the same mappings as the given Map. The hashtable is created with a capacity of twice the number of entries in the given Map or 11 (whichever is greater), and a default load factor, which is `0.75`.
  Parameters:
    `t` - the map whose mappings are to be placed in this map.
  Since:
    1.2

Method Detail

### size

    public int size()

  Returns the number of keys in this hashtable.
  Specified by:
    `size` in interface `Map`
  Overrides:
    `size` in class `Dictionary`
  Returns:
    the number of keys in this hashtable.

### isEmpty

    public boolean isEmpty()

  Tests if this hashtable maps no keys to values.
  Specified by:
    `isEmpty` in interface `Map`
  Overrides:
    `isEmpty` in class `Dictionary`
  Returns:
    `true` if this hashtable maps no keys to values; `false` otherwise.

### keys

    public Enumeration keys()

  Returns an enumeration of the keys in this hashtable.
  Overrides:
    `keys` in class `Dictionary`
  Returns:
    an enumeration of the keys in this hashtable.
  See Also:
    `Enumeration`, `elements()`, `keySet()`, `Map`

### elements

    public Enumeration elements()

  Returns an enumeration of the values in this hashtable. Use the Enumeration methods on the returned object to fetch the elements sequentially.
  Overrides:
    `elements` in class `Dictionary`
  Returns:
    an enumeration of the values in this hashtable.
  See Also:
    `Enumeration`, `keys()`, `values()`, `Map`

### contains

    public boolean contains(Object value)

  Tests if some key maps into the specified value in this hashtable. This operation is more expensive than the `containsKey` method.

  Note that this method is identical in functionality to containsValue, (which is part of the Map interface in the collections framework).

  Parameters:
    `value` - a value to search for.
  Returns:
    `true` if and only if some key maps to the `value` argument in this hashtable as determined by the `equals` method; `false` otherwise.
  Throws:
    `NullPointerException` - if the value is `null`.
  See Also:
    `containsKey(Object)`, `containsValue(Object)`, `Map`

### containsValue

    public boolean containsValue(Object value)

  Returns true if this Hashtable maps one or more keys to this value.

  Note that this method is identical in functionality to contains (which predates the Map interface).

  Specified by:
    `containsValue` in interface `Map`
  Parameters:
    `value` - value whose presence in this Hashtable is to be tested.
  Returns:
    `true` if this map maps one or more keys to the specified value.
  Since:
    1.2
  See Also:
    `Map`

### containsKey

    public boolean containsKey(Object key)

  Tests if the specified object is a key in this hashtable.
  Specified by:
    `containsKey` in interface `Map`
  Parameters:
    `key` - possible key.
  Returns:
    `true` if and only if the specified object is a key in this hashtable, as determined by the `equals` method; `false` otherwise.
  See Also:
    `contains(Object)`

### get

    public Object get(Object key)

  Returns the value to which the specified key is mapped in this hashtable.
  Specified by:
    `get` in interface `Map`
  Overrides:
    `get` in class `Dictionary`
  Parameters:
    `key` - a key in the hashtable.
  Returns:
    the value to which the key is mapped in this hashtable; `null` if the key is not mapped to any value in this hashtable.
  See Also:
    `put(Object, Object)`

### rehash

    protected void rehash()

  Increases the capacity of and internally reorganizes this hashtable, in order to accommodate and access its entries more efficiently. This method is called automatically when the number of keys in the hashtable exceeds this hashtable's capacity and load factor.

### put

    public Object put(Object key,
                      Object value)

  Maps the specified `key` to the specified `value` in this hashtable. Neither the key nor the value can be `null`.

  The value can be retrieved by calling the `get` method with a key that is equal to the original key.

  Specified by:
    `put` in interface `Map`
  Overrides:
    `put` in class `Dictionary`
  Parameters:
    `key` - the hashtable key.
    `value` - the value.
  Returns:
    the previous value of the specified key in this hashtable, or `null` if it did not have one.
  Throws:
    `NullPointerException` - if the key or value is `null`.
  See Also:
    `Object.equals(Object)`, `get(Object)`

### remove

    public Object remove(Object key)

  Removes the key (and its corresponding value) from this hashtable. This method does nothing if the key is not in the hashtable.
  Specified by:
    `remove` in interface `Map`
  Overrides:
    `remove` in class `Dictionary`
  Parameters:
    `key` - the key that needs to be removed.
  Returns:
    the value to which the key had been mapped in this hashtable, or `null` if the key did not have a mapping.

### putAll

    public void putAll(Map t)

  Copies all of the mappings from the specified Map to this Hashtable These mappings will replace any mappings that this Hashtable had for any of the keys currently in the specified Map.
  Specified by:
    `putAll` in interface `Map`
  Parameters:
    `t` - Mappings to be stored in this map.
  Since:
    1.2

### clear

    public void clear()

  Clears this hashtable so that it contains no keys.
  Specified by:
    `clear` in interface `Map`
  Following copied from interface: `java.util.Map`
  Throws:
    `UnsupportedOperationException` - clear is not supported by this map.

### clone

    public Object clone()

  Creates a shallow copy of this hashtable. All the structure of the hashtable itself is copied, but the keys and values are not cloned. This is a relatively expensive operation.
  Overrides:
    `clone` in class `Object`
  Returns:
    a clone of the hashtable.

### toString

    public String toString()

  Returns a string representation of this `Hashtable` object in the form of a set of entries, enclosed in braces and separated by the ASCII characters "`,` " (comma and space). Each entry is rendered as the key, an equals sign `=`, and the associated element, where the `toString` method is used to convert the key and element to strings.

  Overrides to `toString` method of `Object`.

  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of this hashtable.

### keySet

    public Set keySet()

  Returns a Set view of the keys contained in this Hashtable. The Set is backed by the Hashtable, so changes to the Hashtable are reflected in the Set, and vice-versa. The Set supports element removal (which removes the corresponding entry from the Hashtable), but not element addition.
  Specified by:
    `keySet` in interface `Map`
  Returns:
    a set view of the keys contained in this map.
  Since:
    1.2

### entrySet

    public Set entrySet()

  Returns a Set view of the entries contained in this Hashtable. Each element in this collection is a Map.Entry. The Set is backed by the Hashtable, so changes to the Hashtable are reflected in the Set, and vice-versa. The Set supports element removal (which removes the corresponding entry from the Hashtable), but not element addition.
  Specified by:
    `entrySet` in interface `Map`
  Returns:
    a set view of the mappings contained in this map.
  Since:
    1.2
  See Also:
    `Map.Entry`

### values

    public Collection values()

  Returns a Collection view of the values contained in this Hashtable. The Collection is backed by the Hashtable, so changes to the Hashtable are reflected in the Collection, and vice-versa. The Collection supports element removal (which removes the corresponding entry from the Hashtable), but not element addition.
  Specified by:
    `values` in interface `Map`
  Returns:
    a collection view of the values contained in this map.
  Since:
    1.2

### equals

    public boolean equals(Object o)

  Compares the specified Object with this Map for equality, as per the definition in the Map interface.
  Specified by:
    `equals` in interface `Map`
  Overrides:
    `equals` in class `Object`
  Returns:
    true if the specified Object is equal to this Map.
  Since:
    1.2
  See Also:
    `Map.equals(Object)`

### hashCode

    public int hashCode()

  Returns the hash code value for this Map as per the definition in the Map interface.
  Specified by:
    `hashCode` in interface `Map`
  Overrides:
    `hashCode` in class `Object`
  Since:
    1.2
  See Also:
    `Map.hashCode()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.